Index: source/simulation2/system/ComponentManager.h
===================================================================
--- source/simulation2/system/ComponentManager.h	(revision 11571)
+++ source/simulation2/system/ComponentManager.h	(working copy)
@@ -233,6 +233,7 @@
 	static int Script_AddLocalEntity(void* cbdata, std::string templateName);
 	static void Script_DestroyEntity(void* cbdata, int ent);
 	static CScriptVal Script_ReadJSONFile(void* cbdata, std::wstring fileName);
+	static std::vector<std::string> Script_FindAllTechnologyTemplates(void* cbdata);
 
 	CMessage* ConstructMessage(int mtid, CScriptVal data);
 	void SendGlobalMessage(entity_id_t ent, const CMessage& msg) const;
Index: source/simulation2/system/ComponentManager.cpp
===================================================================
--- source/simulation2/system/ComponentManager.cpp	(revision 11571)
+++ source/simulation2/system/ComponentManager.cpp	(working copy)
@@ -81,6 +81,7 @@
 		m_ScriptInterface.RegisterFunction<int, std::string, CComponentManager::Script_AddLocalEntity> ("AddLocalEntity");
 		m_ScriptInterface.RegisterFunction<void, int, CComponentManager::Script_DestroyEntity> ("DestroyEntity");
 		m_ScriptInterface.RegisterFunction<CScriptVal, std::wstring, CComponentManager::Script_ReadJSONFile> ("ReadJSONFile");
+		m_ScriptInterface.RegisterFunction<std::vector<std::string>, CComponentManager::Script_FindAllTechnologyTemplates> ("FindAllTechnologyTemplates");
 	}
 
 	// Define MT_*, IID_* as script globals, and store their names
@@ -944,3 +945,29 @@
 
 	return componentManager->GetScriptInterface().ReadJSONFile(path).get();
 }
+
+static Status AddToTechnologyTemplates(const VfsPath& pathname, const FileInfo& UNUSED(fileInfo), const uintptr_t cbData)
+{
+	std::vector<std::string>& templates = *(std::vector<std::string>*)cbData;
+
+	// Strip the .json extension
+	VfsPath pathstem = pathname.ChangeExtension(L"");
+	// Strip the root from the path
+	std::wstring name = pathstem.string().substr(ARRAY_SIZE("simulation/data/technologies/")-1);
+
+	templates.push_back(std::string(name.begin(), name.end()));
+	return INFO::OK;
+}
+
+std::vector<std::string> CComponentManager::Script_FindAllTechnologyTemplates(void* cbdata)
+{
+	std::vector<std::string> templates;
+
+	Status ok;
+
+	// Find all the technology template files
+	ok = vfs::ForEachFile(g_VFS, "simulation/data/technologies/", AddToTechnologyTemplates, (uintptr_t)&templates, L"*.json", vfs::DIR_RECURSIVE);
+	WARN_IF_ERR(ok);
+
+	return templates;
+}
Index: source/simulation2/Simulation2.cpp
===================================================================
--- source/simulation2/Simulation2.cpp	(revision 11571)
+++ source/simulation2/Simulation2.cpp	(working copy)
@@ -125,6 +125,7 @@
 			LOAD_SCRIPTED_COMPONENT("GuiInterface");
 			LOAD_SCRIPTED_COMPONENT("PlayerManager");
 			LOAD_SCRIPTED_COMPONENT("Timer");
+			LOAD_SCRIPTED_COMPONENT("TechnologyTemplateManager");
 
 #undef LOAD_SCRIPTED_COMPONENT
 		}
Index: binaries/data/mods/public/gui/session/input.js
===================================================================
--- binaries/data/mods/public/gui/session/input.js	(revision 11571)
+++ binaries/data/mods/public/gui/session/input.js	(working copy)
@@ -764,7 +764,7 @@
 		case "hotkeyup":
 			if (ev.hotkey == "session.batchtrain")
 			{
-				flushTrainingQueueBatch();
+				flushTrainingBatch();
 				inputState = INPUT_NORMAL;
 			}
 			break;
@@ -1202,13 +1202,13 @@
 var batchTrainingCount;
 const batchIncrementSize = 5;
 
-function flushTrainingQueueBatch()
+function flushTrainingBatch()
 {
 	Engine.PostNetworkCommand({"type": "train", "entity": batchTrainingEntity, "template": batchTrainingType, "count": batchTrainingCount});
 }
 
 // Called by GUI when user clicks training button
-function addToTrainingQueue(entity, trainEntType)
+function addTrainingToQueue(entity, trainEntType)
 {
 	if (Engine.HotkeyIsPressed("session.batchtrain"))
 	{
@@ -1223,7 +1223,7 @@
 			// Otherwise start a new one
 			else
 			{
-				flushTrainingQueueBatch();
+				flushTrainingBatch();
 				// fall through to create the new batch
 			}
 		}
@@ -1239,9 +1239,15 @@
 	}
 }
 
+// Called by GUI when user clicks training button
+function addResearchToQueue(entity, trainEntType)
+{
+	Engine.PostNetworkCommand({"type": "research", "entity": entity, "template": trainEntType});
+}
+
 // Returns the number of units that will be present in a batch if the user clicks
 // the training button with shift down
-function getTrainingQueueBatchStatus(entity, trainEntType)
+function getTrainingBatchStatus(entity, trainEntType)
 {
 	if (inputState == INPUT_BATCHTRAINING && batchTrainingEntity == entity && batchTrainingType == trainEntType)
 		return [batchTrainingCount, batchIncrementSize];
@@ -1250,9 +1256,9 @@
 }
 
 // Called by GUI when user clicks production queue item
-function removeFromTrainingQueue(entity, id)
+function removeFromProductionQueue(entity, id)
 {
-	Engine.PostNetworkCommand({"type": "stop-train", "entity": entity, "id": id});
+	Engine.PostNetworkCommand({"type": "stop-production", "entity": entity, "id": id});
 }
 
 // Called by unit selection buttons
Index: binaries/data/mods/public/gui/session/unit_commands.js
===================================================================
--- binaries/data/mods/public/gui/session/unit_commands.js	(revision 11571)
+++ binaries/data/mods/public/gui/session/unit_commands.js	(working copy)
@@ -4,6 +4,7 @@
 const GARRISON = "Garrison";
 const FORMATION = "Formation";
 const TRAINING = "Training";
+const RESEARCH = "Research";
 const CONSTRUCTION = "Construction";
 const COMMAND = "Command";
 const STANCE = "Stance";
@@ -23,7 +24,7 @@
 const BARTER_ACTIONS = ["Sell", "Buy"];
 
 // The number of currently visible buttons (used to optimise showing/hiding)
-var g_unitPanelButtons = {"Selection": 0, "Queue": 0, "Formation": 0, "Garrison": 0, "Training": 0, "Barter": 0, "Trading": 0, "Construction": 0, "Command": 0, "Stance": 0};
+var g_unitPanelButtons = {"Selection": 0, "Queue": 0, "Formation": 0, "Garrison": 0, "Training": 0, "Research": 0, "Barter": 0, "Trading": 0, "Construction": 0, "Command": 0, "Stance": 0};
 
 // Unit panels are panels with row(s) of buttons
 var g_unitPanels = ["Selection", "Queue", "Formation", "Garrison", "Training", "Barter", "Trading", "Construction", "Research", "Stance", "Command"];
@@ -163,6 +164,11 @@
 			if (numberOfItems > 24)
 				numberOfItems =  24;
 			break;
+		
+		case RESEARCH:
+			if (numberOfItems > 8)
+				numberOfItems =  8;
+			break;
 
 		case CONSTRUCTION:
 			if (numberOfItems > 24)
@@ -183,13 +189,54 @@
 	for (i = 0; i < numberOfItems; i++)
 	{
 		var item = items[i];
-		var entType = ((guiName == "Queue")? item.template : item);
+		
+		// If a tech has been researched it leaves an empty slot
+		if (guiName == RESEARCH && !item)
+		{
+			getGUIObjectByName("unit"+guiName+"Button["+i+"]").hidden = true;
+			continue;
+		}
+		
+		// Get the entity type and load the template for that type if necessary
+		var entType;
 		var template;
-		if (guiName != "Formation" && guiName != "Command" && guiName != "Stance")
+		switch (guiName)
 		{
-			template = GetTemplateData(entType);
-			if (!template)
-				continue; // ignore attempts to use invalid templates (an error should have been reported already)
+			case QUEUE:
+				// The queue can hold both technologies and units so we need to use the correct code for
+				// loading the templates
+				if (item.unitTemplate)
+				{
+					entType = item.unitTemplate;
+					template = GetTemplateData(entType);
+				}
+				else if (item.technologyTemplate)
+				{
+					entType = item.technologyTemplate;
+					template = GetTechnologyData(entType);
+				}
+			
+				if (!template)
+					continue; // ignore attempts to use invalid templates (an error should have been
+					          // reported already)
+				break;
+			case RESEARCH:
+				entType = item;
+				template = GetTechnologyData(entType);
+				if (!template)
+					continue; // ignore attempts to use invalid templates (an error should have been
+					          // reported already)
+				break;
+			case SELECTION:
+			case GARRISON:
+			case TRAINING:
+			case CONSTRUCTION:
+				entType = item;
+				template = GetTemplateData(entType);
+				if (!template)
+					continue; // ignore attempts to use invalid templates (an error should have been
+					          // reported already)
+				break;
 		}
 
 		switch (guiName)
@@ -233,7 +280,7 @@
 				if (template.tooltip)
 					tooltip += "\n[font=\"serif-13\"]" + template.tooltip + "[/font]";
 
-				var [batchSize, batchIncrement] = getTrainingQueueBatchStatus(unitEntState.id, entType);
+				var [batchSize, batchIncrement] = getTrainingBatchStatus(unitEntState.id, entType);
 				var trainNum = batchSize ? batchSize+batchIncrement : batchIncrement;
 
 				tooltip += "\n" + getEntityCost(template);
@@ -250,7 +297,16 @@
 				tooltip += "\n\n[font=\"serif-bold-13\"]Shift-click[/font][font=\"serif-13\"] to train " + trainNum + ".[/font]";
 
 				break;
+				
+			case RESEARCH:
+				var tooltip = getEntityNameWithGenericType(template);
 
+				if (template.tooltip)
+					tooltip += "\n[font=\"serif-13\"]" + template.tooltip + "[/font]";
+
+				tooltip += "\n" + getEntityCost(template);
+				break;
+
 			case CONSTRUCTION:
 				var tooltip = getEntityNameWithGenericType(template);
 				if (template.tooltip)
@@ -352,7 +408,25 @@
 		}
 		else if (template.icon)
 		{
-			icon.sprite = "stretched:session/portraits/" + template.icon;
+			var grayscale = "";
+			button.enabled = true;
+			
+			if (template.requiredTechnology && !Engine.GuiInterfaceCall("IsTechnologyResearched", template.requiredTechnology))
+			{
+				button.enabled = false;
+				var techName = getEntityName(GetTechnologyData(template.requiredTechnology));
+				button.tooltip += "\nRequires " + techName;
+				grayscale = "grayscale:";
+			}
+			
+			if (guiName == RESEARCH && !Engine.GuiInterfaceCall("CheckTechnologyRequirements", entType))
+			{
+				button.enabled = false;
+				button.tooltip += "\n" + GetTechnologyData(entType).requirementsTooltip;
+				grayscale = "grayscale:";
+			}
+			
+			icon.sprite = "stretched:" + grayscale + "session/portraits/" + template.icon;
 		}
 		else
 		{
@@ -537,16 +611,22 @@
 		{
 			setupUnitPanel("Construction", usedPanels, entState, entState.buildEntities, startBuildingPlacement);
 		}
-
-		if (entState.training && entState.training.entities.length)
+		
+		if (entState.production && entState.production.entities.length)
 		{
-			setupUnitPanel("Training", usedPanels, entState, entState.training.entities,
-				function (trainEntType) { addToTrainingQueue(entState.id, trainEntType); } );
+			setupUnitPanel("Training", usedPanels, entState, entState.production.entities,
+				function (trainEntType) { addTrainingToQueue(entState.id, trainEntType); } );
 		}
+		
+		if (entState.production && entState.production.technologies.length)
+		{
+			setupUnitPanel("Research", usedPanels, entState, entState.production.technologies,
+				function (researchType) { addResearchToQueue(entState.id, researchType); } );
+		}
 
-		if (entState.training && entState.training.queue.length)
-			setupUnitPanel("Queue", usedPanels, entState, entState.training.queue,
-				function (item) { removeFromTrainingQueue(entState.id, item.id); } );
+		if (entState.production && entState.production.queue.length)
+			setupUnitPanel("Queue", usedPanels, entState, entState.production.queue,
+				function (item) { removeFromProductionQueue(entState.id, item.id); } );
 
 		if (entState.trader)
 		{
Index: binaries/data/mods/public/gui/session/session.js
===================================================================
--- binaries/data/mods/public/gui/session/session.js	(revision 11571)
+++ binaries/data/mods/public/gui/session/session.js	(working copy)
@@ -15,7 +15,7 @@
 
 // Indicate when one of the current player's training queues is blocked
 // (this is used to support population counter blinking)
-var g_IsTrainingQueueBlocked = false;
+var g_IsTrainingBlocked = false;
 
 // Cache EntityStates
 var g_EntityStates = {}; // {id:entState}
@@ -53,6 +53,20 @@
 	return g_TemplateData[templateName];
 }
 
+// Cache TechnologyData
+var g_TechnologyData = {}; // {id:template}
+
+function GetTechnologyData(technologyName)
+{
+	if (!(technologyName in g_TechnologyData))
+	{
+		var template = Engine.GuiInterfaceCall("GetTechnologyData", technologyName);
+		g_TechnologyData[technologyName] = template;
+	}
+
+	return g_TechnologyData[technologyName];
+}
+
 // Init
 function init(initData, hotloadData)
 {
@@ -206,7 +220,7 @@
 	global.music.updateTimer();
 
 	// When training is blocked, flash population (alternates colour every 500msec)
-	if (g_IsTrainingQueueBlocked && (Date.now() % 1000) < 500)
+	if (g_IsTrainingBlocked && (Date.now() % 1000) < 500)
 		getGUIObjectByName("resourcePop").textcolor = POPULATION_ALERT_COLOR;
 	else
 		getGUIObjectByName("resourcePop").textcolor = DEFAULT_POPULATION_COLOR;
@@ -257,6 +271,7 @@
 	g_Selection.dirty = false;
 	g_EntityStates = {};
 	g_TemplateData = {};
+	g_TechnologyData = {};
 
 	var simState = Engine.GuiInterfaceCall("GetSimulationState");
 
@@ -345,7 +360,7 @@
 	getGUIObjectByName("resourceMetal").caption = playerState.resourceCounts.metal;
 	getGUIObjectByName("resourcePop").caption = playerState.popCount + "/" + playerState.popLimit;
 
-	g_IsTrainingQueueBlocked = playerState.trainingQueueBlocked;
+	g_IsTrainingBlocked = playerState.trainingBlocked;
 }
 
 function updateTimeElapsedCounter(simState)
Index: binaries/data/mods/public/simulation/helpers/Commands.js
===================================================================
--- binaries/data/mods/public/simulation/helpers/Commands.js	(revision 11571)
+++ binaries/data/mods/public/simulation/helpers/Commands.js	(working copy)
@@ -135,9 +135,18 @@
 		// Verify that the building can be controlled by the player
 		if (CanControlUnit(cmd.entity, player, controlAllUnits))
 		{
-			var queue = Engine.QueryInterface(cmd.entity, IID_TrainingQueue);
-			if (queue)
-				queue.AddBatch(cmd.template, +cmd.count, cmd.metadata);
+			var cmpTechMan = QueryOwnerInterface(cmd.entity, IID_TechnologyManager);
+			// TODO: Enable this check once the AI gets technology support
+			if (cmpTechMan.CanProduce(cmd.template) || true)
+			{
+				var queue = Engine.QueryInterface(cmd.entity, IID_ProductionQueue);
+				if (queue)
+					queue.AddBatch(cmd.template, "unit", +cmd.count, cmd.metadata);
+			}
+			else if (g_DebugCommands)
+			{
+				warn("Invalid command: training requires unresearched technology: " + uneval(cmd));
+			}
 		}
 		else if (g_DebugCommands)
 		{
@@ -145,17 +154,40 @@
 		}
 		break;
 
-	case "stop-train":
+	case "research":
 		// Verify that the building can be controlled by the player
 		if (CanControlUnit(cmd.entity, player, controlAllUnits))
 		{
-			var queue = Engine.QueryInterface(cmd.entity, IID_TrainingQueue);
+			var cmpTechMan = QueryOwnerInterface(cmd.entity, IID_TechnologyManager);
+			// TODO: Enable this check once the AI gets technology support
+			if (cmpTechMan.CanResearch(cmd.template) || true)
+			{
+				var queue = Engine.QueryInterface(cmd.entity, IID_ProductionQueue);
+				if (queue)
+					queue.AddBatch(cmd.template, "technology");
+			}
+			else if (g_DebugCommands)
+			{
+				warn("Invalid command: Requirements to research technology are not met: " + uneval(cmd));
+			}
+		}
+		else if (g_DebugCommands)
+		{
+			warn("Invalid command: research building cannot be controlled by player "+player+": "+uneval(cmd));
+		}
+		break;
+
+	case "stop-production":
+		// Verify that the building can be controlled by the player
+		if (CanControlUnit(cmd.entity, player, controlAllUnits))
+		{
+			var queue = Engine.QueryInterface(cmd.entity, IID_ProductionQueue);
 			if (queue)
 				queue.RemoveBatch(cmd.id);
 		}
 		else if (g_DebugCommands)
 		{
-			warn("Invalid command: training building cannot be controlled by player "+player+": "+uneval(cmd));
+			warn("Invalid command: production building cannot be controlled by player "+player+": "+uneval(cmd));
 		}
 		break;
 
@@ -233,7 +265,23 @@
 			Engine.DestroyEntity(ent);
 			break;
 		}
+		
+		var cmpTechMan = QueryPlayerIDInterface(player, IID_TechnologyManager);
+		// TODO: Enable this check once the AI gets technology support
+		if (!cmpTechMan.CanProduce(cmd.template) && false)
+		{
+			if (g_DebugCommands)
+			{
+				warn("Invalid command: required technology check failed for player "+player+": "+uneval(cmd));
+			}
 
+			var cmpGuiInterface = Engine.QueryInterface(SYSTEM_ENTITY, IID_GuiInterface);
+			cmpGuiInterface.PushNotification({ "player": player, "message": "Building's technology requirements are not met." });
+
+			// Remove the foundation because the construction was aborted
+			Engine.DestroyEntity(ent);
+		}
+
 		// TODO: AI has no visibility info
 		if (!cmpPlayer.IsAI())
 		{
Index: binaries/data/mods/public/simulation/components/GuiInterface.js
===================================================================
--- binaries/data/mods/public/simulation/components/GuiInterface.js	(revision 11571)
+++ binaries/data/mods/public/simulation/components/GuiInterface.js	(working copy)
@@ -66,7 +66,7 @@
 			"popLimit": cmpPlayer.GetPopulationLimit(),
 			"popMax": cmpPlayer.GetMaxPopulation(),
 			"resourceCounts": cmpPlayer.GetResourceCounts(),
-			"trainingQueueBlocked": cmpPlayer.IsTrainingQueueBlocked(),
+			"trainingBlocked": cmpPlayer.IsTrainingBlocked(),
 			"state": cmpPlayer.GetState(),
 			"team": cmpPlayer.GetTeam(),
 			"phase": cmpPlayer.GetPhase(),
@@ -177,12 +177,13 @@
 		ret.buildEntities = cmpBuilder.GetEntitiesList();
 	}
 
-	var cmpTrainingQueue = Engine.QueryInterface(ent, IID_TrainingQueue);
-	if (cmpTrainingQueue)
+	var cmpProductionQueue = Engine.QueryInterface(ent, IID_ProductionQueue);
+	if (cmpProductionQueue)
 	{
-		ret.training = {
-			"entities": cmpTrainingQueue.GetEntitiesList(),
-			"queue": cmpTrainingQueue.GetQueue(),
+		ret.production = {
+			"entities": cmpProductionQueue.GetEntitiesList(),
+			"technologies": cmpProductionQueue.GetTechnologiesList(),
+			"queue": cmpProductionQueue.GetQueue(),
 		};
 	}
 
@@ -346,6 +347,7 @@
 		};
 		ret.icon = template.Identity.Icon;
 		ret.tooltip =  template.Identity.Tooltip;
+		ret.requiredTechnology = template.Identity.RequiredTechnology;
 	}
 
 	if (template.UnitMotion)
@@ -359,6 +361,68 @@
 	return ret;
 };
 
+GuiInterface.prototype.GetTechnologyData = function(player, name)
+{
+	var cmpTechTempMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_TechnologyTemplateManager);
+	var template = cmpTechTempMan.GetTemplate(name);
+	
+	if (!template)
+	{
+		warn("tried to get data for invaalid technology: " + name);
+		return null;
+	}
+	
+	var ret = {};
+	
+	var cmpPlayer = QueryPlayerIDInterface(player, IID_Player);
+	var specific = template.specificName;
+	if (template["specificName_" + cmpPlayer.GetCiv()])
+		specific = template["specificName_" + cmpPlayer.GetCiv()];
+	
+	ret.name = {
+		"specific": specific,
+		"generic": template.genericName,
+	};
+	ret.icon = template.icon;
+	ret.cost = {
+		"food": +template.cost.food,
+		"wood": +template.cost.wood,
+		"metal": +template.cost.metal,
+		"stone": +template.cost.stone,
+	}
+	ret.tooltip = template.tooltip;
+	
+	if (template.requirementsTooltip)
+		ret.requirementsTooltip = template.requirementsTooltip;
+	else
+		ret.requirementsTooltip = "";
+	
+	ret.description = template.description;
+	
+	return ret;
+};
+
+GuiInterface.prototype.IsTechnologyResearched = function(player, tech)
+{
+	var cmpTechMan = QueryPlayerIDInterface(player, IID_TechnologyManager);
+	
+	if (!cmpTechMan)
+		return false;
+	
+	return cmpTechMan.IsTechnologyResearched(tech);
+}
+
+// Checks whether the requirements for this technology have been met
+GuiInterface.prototype.CheckTechnologyRequirements = function(player, tech)
+{
+	var cmpTechMan = QueryPlayerIDInterface(player, IID_TechnologyManager);
+	
+	if (!cmpTechMan)
+		return false;
+	
+	return cmpTechMan.CanResearch(tech);
+}
+
 GuiInterface.prototype.PushNotification = function(notification)
 {
 	this.notifications.push(notification);
@@ -812,6 +876,9 @@
 	"ClearRenamedEntities": 1,
 	"GetEntityState": 1,
 	"GetTemplateData": 1,
+	"GetTechnologyData": 1,
+	"IsTechnologyResearched": 1,
+	"CheckTechnologyRequirements": 1,
 	"GetNextNotification": 1,
 
 	"GetFormationRequirements": 1,
Index: binaries/data/mods/public/simulation/components/interfaces/TechnologyManager.js
===================================================================
--- binaries/data/mods/public/simulation/components/interfaces/TechnologyManager.js	(revision 0)
+++ binaries/data/mods/public/simulation/components/interfaces/TechnologyManager.js	(revision 0)
@@ -0,0 +1,5 @@
+Engine.RegisterInterface("TechnologyManager");
+
+// Message of the form { "component": "Attack", "player": 3 }
+// Sent when a new technology is researched which modifies a component
+Engine.RegisterMessageType("TechnologyModificationChange");
Index: binaries/data/mods/public/simulation/components/interfaces/ProductionQueue.js
===================================================================
--- binaries/data/mods/public/simulation/components/interfaces/ProductionQueue.js	(revision 11375)
+++ binaries/data/mods/public/simulation/components/interfaces/ProductionQueue.js	(working copy)
@@ -1,8 +1,8 @@
-Engine.RegisterInterface("TrainingQueue");
+Engine.RegisterInterface("ProductionQueue");
 
 // Message of the form { } (use GetQueue if you want the current details),
 // sent to the current entity whenever the training queue changes.
-Engine.RegisterMessageType("TrainingQueueChanged");
+Engine.RegisterMessageType("ProductionQueueChanged");
 
 // Message of the form { entities: [id, ...], metadata: ... }
 // sent to the current entity whenever a unit has been trained.
Index: binaries/data/mods/public/simulation/components/interfaces/TechnologyTemplateManager.js
===================================================================
--- binaries/data/mods/public/simulation/components/interfaces/TechnologyTemplateManager.js	(revision 0)
+++ binaries/data/mods/public/simulation/components/interfaces/TechnologyTemplateManager.js	(revision 0)
@@ -0,0 +1 @@
+Engine.RegisterInterface("TechnologyTemplateManager");
\ No newline at end of file
Index: binaries/data/mods/public/simulation/components/ResourceGatherer.js
===================================================================
--- binaries/data/mods/public/simulation/components/ResourceGatherer.js	(revision 11571)
+++ binaries/data/mods/public/simulation/components/ResourceGatherer.js	(working copy)
@@ -125,19 +125,40 @@
 		return undefined;
 };
 
+// Remove any cached template data which is based on technology data
+ResourceGatherer.prototype.OnTechnologyModificationChange = function(msg)
+{
+	var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
+	if (!cmpOwnership)
+		return;
+	
+	var player = cmpOwnership.GetOwner();
+	
+	if (msg.component === "ResourceGatherer" && msg.player === player)
+		delete this.gatherRatesCache;
+};
+
 ResourceGatherer.prototype.GetGatherRates = function()
 {
-	var ret = {};
-	for (var r in this.template.Rates)
-		ret[r] = this.template.Rates[r] * this.template.BaseSpeed;
-	return ret;
+	if (!this.gatherRatesCache){
+		this.gatherRatesCache = {};
+		var cmpTechManager = QueryOwnerInterface(this.entity, IID_TechnologyManager);
+		var baseSpeed = cmpTechManager.ApplyModifications("ResourceGatherer/BaseSpeed", this.template.BaseSpeed, this.entity);
+		for (var r in this.template.Rates)
+		{
+			var rate = cmpTechManager.ApplyModifications("ResourceGatherer/Rates/" + r, this.template.Rates[r], this.entity);
+			this.gatherRatesCache[r] = rate * baseSpeed;
+		}
+	}
+	
+	return this.gatherRatesCache;
 };
 
 ResourceGatherer.prototype.GetRange = function()
 {
 	return { "max": +this.template.MaxDistance, "min": 0 };
 	// maybe this should depend on the unit or target or something?
-}
+};
 
 /**
  * Try to gather treasure
@@ -223,13 +244,13 @@
 	var type = cmpResourceSupply.GetType();
 
 	var rate;
-	if (type.specific && this.template.Rates[type.generic+"."+type.specific])
-		rate = this.template.Rates[type.generic+"."+type.specific];
+	if (type.specific && this.GetGatherRates()[type.generic+"."+type.specific])
+		rate = this.GetGatherRates()[type.generic+"."+type.specific];
 	else
-		rate = this.template.Rates[type.generic];
+		rate = this.GetGatherRates()[type.generic];
 
-	return (rate || 0) * this.template.BaseSpeed;
-}
+	return (rate || 0);
+};
 
 /**
  * Returns whether this unit can carry more of the given type of resource.
Index: binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js
===================================================================
--- binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js	(revision 11571)
+++ binaries/data/mods/public/simulation/components/tests/test_GuiInterface.js	(working copy)
@@ -12,7 +12,7 @@
 Engine.LoadComponentScript("interfaces/ResourceDropsite.js");
 Engine.LoadComponentScript("interfaces/ResourceGatherer.js");
 Engine.LoadComponentScript("interfaces/ResourceSupply.js");
-Engine.LoadComponentScript("interfaces/TrainingQueue.js");
+Engine.LoadComponentScript("interfaces/ProductionQueue.js");
 Engine.LoadComponentScript("interfaces/Trader.js")
 Engine.LoadComponentScript("interfaces/Timer.js");
 Engine.LoadComponentScript("interfaces/StatisticsTracker.js");
@@ -58,7 +58,7 @@
 	GetPopulationLimit: function() { return 20; },
 	GetMaxPopulation: function() { return 200; },
 	GetResourceCounts: function() { return { food: 100 }; },
-	IsTrainingQueueBlocked: function() { return false; },
+	IsTrainingBlocked: function() { return false; },
 	GetState: function() { return "active"; },
 	GetTeam: function() { return -1; },
 	GetDiplomacy: function() { return [-1, 1]; },
@@ -105,7 +105,7 @@
 	GetPopulationLimit: function() { return 30; },
 	GetMaxPopulation: function() { return 300; },
 	GetResourceCounts: function() { return { food: 200 }; },
-	IsTrainingQueueBlocked: function() { return false; },
+	IsTrainingBlocked: function() { return false; },
 	GetState: function() { return "active"; },
 	GetTeam: function() { return -1; },
 	GetDiplomacy: function() { return [-1, 1]; },
@@ -157,7 +157,7 @@
 			popLimit: 20,
 			popMax: 200,
 			resourceCounts: { food: 100 },
-			trainingQueueBlocked: false,
+			trainingBlocked: false,
 			state: "active",
 			team: -1,
 			phase: "",
@@ -174,7 +174,7 @@
 			popLimit: 30,
 			popMax: 300,
 			resourceCounts: { food: 200 },
-			trainingQueueBlocked: false,
+			trainingBlocked: false,
 			state: "active",
 			team: -1,
 			phase: "village",
@@ -198,7 +198,7 @@
 			popLimit: 20,
 			popMax: 200,
 			resourceCounts: { food: 100 },
-			trainingQueueBlocked: false,
+			trainingBlocked: false,
 			state: "active",
 			team: -1,
 			phase: "",
@@ -231,7 +231,7 @@
 			popLimit: 30,
 			popMax: 300,
 			resourceCounts: { food: 200 },
-			trainingQueueBlocked: false,
+			trainingBlocked: false,
 			state: "active",
 			team: -1,
 			phase: "village",
Index: binaries/data/mods/public/simulation/components/Identity.js
===================================================================
--- binaries/data/mods/public/simulation/components/Identity.js	(revision 11571)
+++ binaries/data/mods/public/simulation/components/Identity.js	(working copy)
@@ -68,6 +68,11 @@
 		"<element name='Icon'>" +
 			"<text/>" +
 		"</element>" +
+	"</optional>" +
+	"<optional>" +
+		"<element name='RequiredTechnology' a:help='Optional name of a technology which must be researched before the entity can be produced'>" +
+			"<text/>" +
+		"</element>" +
 	"</optional>";
 
 
@@ -126,6 +131,6 @@
 Identity.prototype.GetSelectionGroupName = function()
 {
 	return (this.template.SelectionGroupName || "");
-}
+};
 
 Engine.RegisterComponentType(IID_Identity, "Identity", Identity);
Index: binaries/data/mods/public/simulation/components/AIProxy.js
===================================================================
--- binaries/data/mods/public/simulation/components/AIProxy.js	(revision 11571)
+++ binaries/data/mods/public/simulation/components/AIProxy.js	(working copy)
@@ -119,12 +119,12 @@
 	this.changes.unitAIOrderData = msg.to;
 };
 
-AIProxy.prototype.OnTrainingQueueChanged = function(msg)
+AIProxy.prototype.OnProductionQueueChanged = function(msg)
 {
 	this.NotifyChange();
 
-	var cmpTrainingQueue = Engine.QueryInterface(this.entity, IID_TrainingQueue);
-	this.changes.trainingQueue = cmpTrainingQueue.GetQueue();
+	var cmpProductionQueue = Engine.QueryInterface(this.entity, IID_ProductionQueue);
+	this.changes.trainingQueue = cmpProductionQueue.GetQueue();
 };
 
 AIProxy.prototype.OnGarrisonedUnitsChanged = function(msg)
@@ -206,11 +206,11 @@
 		ret.unitAIOrderData = cmpUnitAI.GetOrderData();
 	}
 
-	var cmpTrainingQueue = Engine.QueryInterface(this.entity, IID_TrainingQueue);
-	if (cmpTrainingQueue)
+	var cmpProductionQueue = Engine.QueryInterface(this.entity, IID_ProductionQueue);
+	if (cmpProductionQueue)
 	{
-		// Updated by OnTrainingQueueChanged
-		ret.trainingQueue = cmpTrainingQueue.GetQueue();
+		// Updated by OnProductionQueueChanged
+		ret.trainingQueue = cmpProductionQueue.GetQueue();
 	}
 
 	var cmpFoundation = Engine.QueryInterface(this.entity, IID_Foundation);
Index: binaries/data/mods/public/simulation/components/Player.js
===================================================================
--- binaries/data/mods/public/simulation/components/Player.js	(revision 11571)
+++ binaries/data/mods/public/simulation/components/Player.js	(working copy)
@@ -12,7 +12,7 @@
 	this.popUsed = 0; // population of units owned or trained by this player
 	this.popBonuses = 0; // sum of population bonuses of player's entities
 	this.maxPop = 300; // maximum population
-	this.trainingQueueBlocked = false; // indicates whether any training queue is currently blocked
+	this.trainingBlocked = false; // indicates whether any training queue is currently blocked
 	this.resourceCount = {
 		"food": 1000,	
 		"wood": 1000,	
@@ -104,19 +104,19 @@
 	return this.maxPop;
 };
 
-Player.prototype.IsTrainingQueueBlocked = function()
+Player.prototype.IsTrainingBlocked = function()
 {
-	return this.trainingQueueBlocked;
+	return this.trainingBlocked;
 };
 
-Player.prototype.BlockTrainingQueue = function()
+Player.prototype.BlockTraining = function()
 {
-	this.trainingQueueBlocked = true;
+	this.trainingBlocked = true;
 };
 
-Player.prototype.UnBlockTrainingQueue = function()
+Player.prototype.UnBlockTraining = function()
 {
-	this.trainingQueueBlocked = false;
+	this.trainingBlocked = false;
 };
 
 Player.prototype.SetResourceCounts = function(resources)
